#include <stdbool.h>
#include <assert.h>

#define MAX_CAPACITY 500
typedef struct _stack {
int data[MAX_CAPACITY]; // les données
int top; // indice du sommet
} stack;

void stack_init(stack *s) {
    s->top = -1;
}

bool stack_is_empty(stack s) {
    return s.top == -1;
}

void stack_push(stack *s, int val) {
    assert(s->top < MAX_CAPACITY - 1);
    s->top += 1;
    s->data[s->top] = val;
}

int stack_pop(stack *s) {
    assert(s->top >= 0);
    s->top -= 1;
    return s->data[s->top+1];
}

int stack_peek(stack *s) {
    assert(s->top >= 0);
    return s->data[s->top];
}